<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des organismes prescripteurs n'ont pas pu être chargées."
    />
    <template v-else-if="followUpOrganismesCounts">
      <h2 class="fr-h5">Organismes prescripteurs</h2>
      <p>
        Pourcentage calculé sur le nombre total
        {{ collection === 'help_requests' ? 'de demandes' : "d'entretiens" }}
      </p>
      <StatsList
        v-if="followUpOrganismesCounts.length"
        :total-count="totalCount"
        :stats="followUpOrganismesCounts"
      />
      <p v-else>{{ emptyResultMessage }}</p>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { COLLECTION_COLORS } from '~~/utils/constants/chart'
  import { errorResponseMessage } from '~~/utils/errorResponse'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    totalCount: {
      type: Number,
      required: true
    },
    collection: {
      type: String,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: followUpOrganismesCounts,
    pending,
    error
  } = useLazyAsyncData(
    `${props.collection}FollowUpOrganismesCounts`,
    loadFollowUpOrganismesCounts,
    {
      server: false
    }
  )

  const emptyResultMessage = computed(() => {
    return `Commencez à créer des ${
      props.collection === 'help_requests'
        ? "instructions de demande d'aides"
        : "synthèses d'entretien"
    } dans les fiches de bénéficiaires pour voir apparaître les statistiques de la répartition des organismes prescripteurs.`
  })

  async function loadFollowUpOrganismesCounts() {
    const res = await $getItems(props.collection, {
      fields: ['organisme_prescripteur.id', 'organisme_prescripteur.name'],
      filter: {
        ...props.filters
      }
    })

    if (res.status === 200) {
      const followUpOrganismesResCounts = {}
      res.data.data.forEach(historyItem => {
        const organismePrescripteurId =
          historyItem.organisme_prescripteur?.id || null
        if (organismePrescripteurId in followUpOrganismesResCounts) {
          followUpOrganismesResCounts[organismePrescripteurId].count++
        } else {
          followUpOrganismesResCounts[organismePrescripteurId] = {
            key: organismePrescripteurId,
            label: historyItem.organisme_prescripteur?.name || 'Non renseigné',
            color: COLLECTION_COLORS[props.collection],
            count: 1
          }
        }
      })
      const followUpOrganismesResCountsValues = Object.values(
        followUpOrganismesResCounts
      )
      followUpOrganismesResCountsValues.sort((a, b) => b.count - a.count)
      return followUpOrganismesResCountsValues
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
